Index: configure.in
===================================================================
RCS file: /repo/OpenLDAP/pkg/ldap/configure.in,v
retrieving revision 1.660
diff -u -r1.660 configure.in
--- configure.in	7 Sep 2007 10:02:43 -0000	1.660
+++ configure.in	13 Sep 2007 09:28:13 -0000
@@ -334,6 +334,7 @@
 	dds \
 	dyngroup \
 	dynlist \
+	rdynlist \
 	memberof \
 	ppolicy \
 	proxycache \
@@ -363,6 +364,8 @@
 	no, [no yes mod], ol_enable_overlays)
 OL_ARG_ENABLE(dynlist,[    --enable-dynlist	  Dynamic List overlay],
 	no, [no yes mod], ol_enable_overlays)
+OL_ARG_ENABLE(rdynlist,[    --enable-rdynlist	  Really Dynamic List overlay],
+	no, [no yes mod], ol_enable_overlays)
 OL_ARG_ENABLE(memberof,[    --enable-memberof	  Reverse Group Membership overlay],
 	no, [no yes mod], ol_enable_overlays)
 OL_ARG_ENABLE(ppolicy,[    --enable-ppolicy	  Password Policy overlay],
@@ -533,6 +536,7 @@
 BUILD_DENYOP=no
 BUILD_DYNGROUP=no
 BUILD_DYNLIST=no
+BUILD_RDYNLIST=no
 BUILD_LASTMOD=no
 BUILD_PPOLICY=no
 BUILD_PROXYCACHE=no
@@ -2737,6 +2741,18 @@
 	AC_DEFINE_UNQUOTED(SLAPD_OVER_DYNLIST,$MFLAG,[define for Dynamic List overlay])
 fi
 
+if test "$ol_enable_rdynlist" != no ; then
+	BUILD_RDYNLIST=$ol_enable_rdynlist
+	if test "$ol_enable_rdynlist" = mod ; then
+		MFLAG=SLAPD_MOD_DYNAMIC
+		SLAPD_DYNAMIC_OVERLAYS="$SLAPD_DYNAMIC_OVERLAYS rdynlist.la"
+	else
+		MFLAG=SLAPD_MOD_STATIC
+		SLAPD_STATIC_OVERLAYS="$SLAPD_STATIC_OVERLAYS rdynlist.o"
+	fi
+	AC_DEFINE_UNQUOTED(SLAPD_OVER_RDYNLIST,$MFLAG,[define for Really Dynamic List overlay])
+fi
+
 if test "$ol_enable_memberof" != no ; then
 	BUILD_MEMBEROF=$ol_enable_memberof
 	if test "$ol_enable_memberof" = mod ; then
@@ -2930,6 +2946,7 @@
   AC_SUBST(BUILD_DENYOP)
   AC_SUBST(BUILD_DYNGROUP)
   AC_SUBST(BUILD_DYNLIST)
+  AC_SUBST(BUILD_RDYNLIST)
   AC_SUBST(BUILD_LASTMOD)
   AC_SUBST(BUILD_PPOLICY)
   AC_SUBST(BUILD_PROXYCACHE)
Index: include/portable.hin
===================================================================
RCS file: /repo/OpenLDAP/pkg/ldap/include/portable.hin,v
retrieving revision 1.40
diff -u -r1.40 portable.hin
--- include/portable.hin	9 Sep 2007 12:23:36 -0000	1.40
+++ include/portable.hin	13 Sep 2007 09:28:13 -0000
@@ -966,6 +966,9 @@
 /* define for Dynamic List overlay */
 #undef SLAPD_OVER_DYNLIST
 
+/* define for Really Dynamic List overlay */
+#undef SLAPD_OVER_RDYNLIST
+
 /* define for Reverse Group Membership overlay */
 #undef SLAPD_OVER_MEMBEROF
 
Index: servers/slapd/bconfig.c
===================================================================
RCS file: /repo/OpenLDAP/pkg/ldap/servers/slapd/bconfig.c,v
retrieving revision 1.303
diff -u -r1.303 bconfig.c
--- servers/slapd/bconfig.c	2 Sep 2007 22:40:52 -0000	1.303
+++ servers/slapd/bconfig.c	13 Sep 2007 09:28:14 -0000
@@ -250,6 +250,7 @@
  * OLcfgOv{Oc|At}:17			-> dyngroup
  * OLcfgOv{Oc|At}:18			-> memberof
  * OLcfgOv{Oc|At}:19			-> collect
+ * OLcfgOv{Oc|At}:20			-> rdynlist
  */
 
 /* alphabetical ordering */
Index: servers/slapd/overlays/Makefile.in
===================================================================
RCS file: /repo/OpenLDAP/pkg/ldap/servers/slapd/overlays/Makefile.in,v
retrieving revision 1.47
diff -u -r1.47 Makefile.in
--- servers/slapd/overlays/Makefile.in	24 Aug 2007 00:46:58 -0000	1.47
+++ servers/slapd/overlays/Makefile.in	13 Sep 2007 09:28:14 -0000
@@ -20,6 +20,7 @@
 	dds.c \
 	dyngroup.c \
 	dynlist.c \
+	rdynlist.c \
 	memberof.c \
 	pcache.c \
 	ppolicy.c \
@@ -77,6 +78,9 @@
 dynlist.la : dynlist.lo
 	$(LTLINK_MOD) -module -o $@ dynlist.lo version.lo $(LINK_LIBS)
 
+rdynlist.la : rdynlist.lo
+	$(LTLINK_MOD) -module -o $@ rdynlist.lo version.lo $(LINK_LIBS)
+
 memberof.la : memberof.lo
 	$(LTLINK_MOD) -module -o $@ memberof.lo version.lo $(LINK_LIBS)
 
Index: servers/slapd/schema/dyngroup.schema
===================================================================
RCS file: /repo/OpenLDAP/pkg/ldap/servers/slapd/schema/dyngroup.schema,v
retrieving revision 1.13
diff -u -r1.13 dyngroup.schema
--- servers/slapd/schema/dyngroup.schema	25 Aug 2007 07:37:59 -0000	1.13
+++ servers/slapd/schema/dyngroup.schema	13 Sep 2007 09:28:14 -0000
@@ -72,7 +72,7 @@
 	SUP top STRUCTURAL
 	MUST cn
 	MAY ( memberURL $ businessCategory $ description $ o $ ou $
-		owner $ seeAlso ) )
+		owner $ seeAlso $ member ) )
 
 # The Haripriya dyngroup schema still needs a lot of work.
 # We're just adding support for the dgIdentity attribute for now...